#include <stdlib.h>
#include <stdio.h>

// it would be better to include gmp-mparam.h !
#define BITS_PER_MP_LIMB 32 

#include "gmp.h"
#include "mpfr.h"

#define ABSSIZE(x) ((x)->_mpfr_size & ((1<<30)-1))
#define SIZE(x) ((x)->_mpfr_size)
#define EXP(x) ((x)->_mpfr_exp)
#define MANT(x) ((x)->_mpfr_d)
#define MPFR_SIGN(x) (((x)->_mpfr_size >> 31) ? -1 : 1)
#define PREC(x) ((x)->_mpfr_prec)
#define NOTZERO(x) (MANT(x)[(PREC(x)-1)/BITS_PER_MP_LIMB])
#define mpfr_sgn(x) ((NOTZERO(x)) ? MPFR_SIGN(x) : 0)     
                      
#define GMP_min -1000000000
#define GMP_max 1000000000

typedef __mpfr_struct  * ext_mpfr_type;
typedef struct {unsigned long mantissa; long exponent; } ext_mpfr_sizetype;

extern long ext_mpfr_var_count;
void ext_mpfr_remove_trailing_zeroes (mpfr_t x);

void ext_mpfr_initialize();

ext_mpfr_type ext_mpfr_init();
void ext_mpfr_free(ext_mpfr_type z);
long ext_mpfr_size(ext_mpfr_type z);
void ext_mpfr_getsize(ext_mpfr_type z,ext_mpfr_sizetype* s);

void ext_mpfr_add(ext_mpfr_type z1,ext_mpfr_type z2,ext_mpfr_type z,long p);
void ext_mpfr_sub(ext_mpfr_type z1,ext_mpfr_type z2,ext_mpfr_type z,long p);
void ext_mpfr_mul(ext_mpfr_type z1,ext_mpfr_type z2,ext_mpfr_type z,long p);
void ext_mpfr_div(ext_mpfr_type z1,ext_mpfr_type z2,ext_mpfr_type z,long p);
void ext_mpfr_abs(ext_mpfr_type z1,ext_mpfr_type z);
void ext_mpfr_truncate(ext_mpfr_type z1,ext_mpfr_type z);


void ext_mpfr_writee(ext_mpfr_type z,long w);
void ext_mpfr_write(ext_mpfr_type z,long w);

void ext_mpfr_duplicate_w_init(ext_mpfr_type z1,ext_mpfr_type *z2);
void ext_mpfr_duplicate_wo_init(ext_mpfr_type z1,ext_mpfr_type z2);

void ext_mpfr_sqrt(ext_mpfr_type z1,ext_mpfr_type z,long p);
void ext_mpfr_shift(ext_mpfr_type z1,ext_mpfr_type z,long p);
